    //compile with mpic++ main.cpp
// run with mpirun -np 4 ./a.out


#include <iostream>
#include <mpi.h>


void calculate_color_and_number_of_groups_for_shared_memory_split(int &color, int &no_of_groups,   int main_node, MPI_Comm comm, int myid, MPI_Comm shared_comm, int myid_on_node, MPI_Comm masters_from_groups_vs_everything_else_comm)
{
//    sh_my_ranks = [my_rank]
//    sh_my_ranks = wrap_mpi_gatherv(sh_my_ranks, main_node, shared_comm)

//    MPI_Comm comm;
//    int gsize,sendarray[1];
//    int root, *rbuf, stride = 1;
//    int *displs,i,*rcounts;
//
//    MPI_Comm_size(comm, &gsize);
//    rbuf = (int *)malloc(gsize*stride*sizeof(int));
//    displs = (int *)malloc(gsize*sizeof(int));
//    rcounts = (int *)malloc(gsize*sizeof(int));
//    for (i=0; i<gsize; ++i) {
//        displs[i] = i*stride;
//        rcounts[i] = 1;
//    }
//    MPI_Gatherv(sendarray, 1, MPI_INT, rbuf, rcounts,
//                displs, MPI_INT, main_node, shared_comm);

//    MPI_Comm comm;

    int i;
    comm = MPI_COMM_WORLD;
    int gsize_sh,sendarray[1] = {myid};
    int  *rbuf;
    MPI_Comm_size( shared_comm, &gsize_sh);
    rbuf = (int *)malloc(gsize_sh*1*sizeof(int));
    MPI_Gather( sendarray, 1, MPI_INT, rbuf, 1, MPI_INT, main_node, shared_comm);


//    group_infos = None
//    if sh_my_rank == main_node:
//# executed only by masters from groups
//    group_infos = [my_rank, sh_my_ranks]
//    group_infos = wrap_mpi_gatherv(group_infos, main_node, masters_from_groups_vs_everything_else_comm)
//
//    mpi_barrier(mpi_comm)


//    MPI_Comm comm;
    int gsize;
    int *rbuf2;
    MPI_Comm_size( comm, &gsize);
    no_of_groups = gsize/gsize_sh;

    int  *sendarray2;
    sendarray2 = (int *)malloc((gsize_sh + 1)*sizeof(int));

    rbuf2 = (int *)malloc(no_of_groups*(gsize_sh + 1)*sizeof(int));

    if (myid_on_node == main_node)
    {

        sendarray2[0] = myid;
        for(i=1;i< (gsize_sh + 1); ++i )
        {
            sendarray2[i] = rbuf[i-1];
        }
        MPI_Gather( sendarray2, 2, MPI_INT, rbuf2, 2, MPI_INT, main_node, masters_from_groups_vs_everything_else_comm);
    }

    MPI_Barrier(comm);


//    group_infos = wrap_mpi_bcast(group_infos, main_node, mpi_comm)

    MPI_Bcast( rbuf2, no_of_groups*(gsize_sh + 1), MPI_INT, main_node, comm);

    std::cout << std::endl;

    for(i=0; i<no_of_groups*(gsize_sh + 1); ++i )
    {
        std::cout << rbuf2[i] << "  ";
    }

    std::cout << std::endl;


}

int main(int argc, char** argv) {
    MPI_Init(&argc, &argv);

    int myid;
    int myid_on_node;
    int color;
    int no_of_groups;
    int nproc;
    int no_of_processes_per_group;

    // all communicator
    MPI_Comm shared_comm;
    MPI_Comm masters_from_groups_vs_everything_else_comm;


    MPI_Comm_rank(MPI_COMM_WORLD, &myid);
    MPI_Comm_size(MPI_COMM_WORLD, &nproc);

    int main_node = 0;

    // shared memory communicator
    MPI_Comm_split_type(MPI_COMM_WORLD, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL, &shared_comm);

    MPI_Comm_rank(shared_comm, &myid_on_node);
    MPI_Comm_size(shared_comm, &no_of_processes_per_group);

    MPI_Comm_split(MPI_COMM_WORLD, main_node == myid_on_node, myid_on_node, &masters_from_groups_vs_everything_else_comm);


    calculate_color_and_number_of_groups_for_shared_memory_split(color, no_of_groups,   main_node, MPI_COMM_WORLD, myid, shared_comm, myid_on_node, masters_from_groups_vs_everything_else_comm);


//    std::size_t local_window_count(10);
//    MPI_Aint size;
//
//    char* base_ptr;
//    MPI_Win win_sm;
//    int disp_unit(sizeof(char));
//
//    if (myid_on_node != 0) local_window_count = 0;
//
//    MPI_Win_allocate_shared(local_window_count * disp_unit, disp_unit, MPI_INFO_NULL, comm_sm, &base_ptr, &win_sm);
//
//    MPI_Win_shared_query(win_sm, 0, &size, &disp_unit, &base_ptr);
//
//    local_window_count = 10;
//
//    // write
//    char buffer;
//    if (rank_sm == 0) {
//        buffer = 'A';
//    }
//    else if (rank_sm == 1) {
//        buffer = 'C';
//    }
//    else if (rank_sm == 2) {
//        buffer = 'G';
//    }
//    else {
//        buffer = 'T';
//    }
//
//    MPI_Win_fence(0, win_sm);
//
//    for (std::size_t it = 0; it < local_window_count; it++) {
//        if (rank_sm == 1) base_ptr[it] = buffer;
//    }
//
//    MPI_Win_fence(0, win_sm);
//
//
//    for (std::size_t it = 0; it < local_window_count; it++) {
//        std::cout << rank_sm << " ---- " << base_ptr[it] << std::endl;
//    }

    MPI_Finalize();

    return 0;
}
